Hex Artifact Content

Artifact 00a188ebb7e9dfb1eb78b347ba5734ffa17af2d4:


0000: 23 21 20 2f 62 69 6e 2f 62 61 73 68 0a 0a 56 45  #! /bin/bash..VE
0010: 52 53 49 4f 4e 53 3d 22 38 2e 34 2e 31 39 20 38  RSIONS="8.4.19 8
0020: 2e 35 2e 39 20 63 76 73 5f 48 45 41 44 22 0a 0a  .5.9 cvs_HEAD"..
0030: 23 20 46 69 6e 64 20 74 68 65 20 62 61 73 65 20  # Find the base 
0040: 64 69 72 65 63 74 6f 72 79 0a 66 6f 72 20 78 20  directory.for x 
0050: 69 6e 20 31 20 32 20 33 20 5f 5f 66 61 69 6c 5f  in 1 2 3 __fail_
0060: 5f 3b 20 64 6f 0a 09 69 66 20 5b 20 22 24 7b 78  _; do..if [ "${x
0070: 7d 22 20 3d 20 22 24 7b 66 61 69 6c 7d 22 20 5d  }" = "${fail}" ]
0080: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 27 55  ; then...echo 'U
0090: 6e 61 62 6c 65 20 74 6f 20 66 69 6e 64 20 4b 69  nable to find Ki
00a0: 74 43 72 65 61 74 6f 72 2c 20 61 62 6f 72 74 69  tCreator, aborti
00b0: 6e 67 2e 27 20 3e 26 32 0a 0a 09 09 65 78 69 74  ng.' >&2....exit
00c0: 20 31 0a 09 66 69 0a 0a 09 69 66 20 5b 20 2d 78   1..fi...if [ -x
00d0: 20 6b 69 74 63 72 65 61 74 6f 72 20 5d 3b 20 74   kitcreator ]; t
00e0: 68 65 6e 0a 09 09 62 72 65 61 6b 0a 09 66 69 0a  hen...break..fi.
00f0: 0a 09 63 64 20 2e 2e 0a 64 6f 6e 65 0a 0a 52 4f  ..cd ...done..RO
0100: 4f 54 44 49 52 3d 22 24 28 70 77 64 29 22 0a 54  OTDIR="$(pwd)".T
0110: 45 53 54 44 49 52 3d 22 24 7b 52 4f 4f 54 44 49  ESTDIR="${ROOTDI
0120: 52 7d 2f 62 75 69 6c 64 2f 74 65 73 74 22 0a 65  R}/build/test".e
0130: 78 70 6f 72 74 20 52 4f 4f 54 44 49 52 20 54 45  xport ROOTDIR TE
0140: 53 54 44 49 52 0a 0a 23 20 48 61 6e 64 6c 65 20  STDIR..# Handle 
0150: 63 6f 6d 6d 61 6e 64 2d 6c 69 6e 65 20 61 72 67  command-line arg
0160: 75 6d 65 6e 74 73 0a 69 66 20 5b 20 22 24 31 22  uments.if [ "$1"
0170: 20 3d 20 22 63 6c 65 61 6e 22 20 5d 3b 20 74 68   = "clean" ]; th
0180: 65 6e 0a 09 72 6d 20 2d 72 66 20 22 24 7b 54 45  en..rm -rf "${TE
0190: 53 54 44 49 52 7d 2f 6b 69 74 73 22 0a 66 69 0a  STDIR}/kits".fi.
01a0: 0a 23 20 43 72 65 61 74 65 20 70 6c 61 63 65 20  .# Create place 
01b0: 74 6f 20 70 75 74 20 6b 69 74 73 0a 6d 6b 64 69  to put kits.mkdi
01c0: 72 20 22 24 7b 54 45 53 54 44 49 52 7d 2f 6b 69  r "${TESTDIR}/ki
01d0: 74 73 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  ts" >/dev/null 2
01e0: 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 69 66 20 5b 20  >/dev/null.if [ 
01f0: 21 20 2d 64 20 22 24 7b 54 45 53 54 44 49 52 7d  ! -d "${TESTDIR}
0200: 2f 6b 69 74 73 22 20 5d 3b 20 74 68 65 6e 0a 09  /kits" ]; then..
0210: 65 63 68 6f 20 27 55 6e 61 62 6c 65 20 74 6f 20  echo 'Unable to 
0220: 63 72 65 61 74 65 20 6b 69 74 73 2f 20 64 69 72  create kits/ dir
0230: 65 63 74 6f 72 79 2c 20 61 62 6f 72 74 69 6e 67  ectory, aborting
0240: 2e 27 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a  .' >&2...exit 1.
0250: 66 69 0a 0a 23 20 43 6c 65 61 6e 75 70 0a 66 6f  fi..# Cleanup.fo
0260: 72 20 66 69 6c 65 20 69 6e 20 22 24 7b 54 45 53  r file in "${TES
0270: 54 44 49 52 7d 22 2f 6b 69 74 73 2f 2a 2e 6c 6f  TDIR}"/kits/*.lo
0280: 67 3b 20 64 6f 0a 09 69 66 20 65 63 68 6f 20 22  g; do..if echo "
0290: 24 7b 66 69 6c 65 7d 22 20 7c 20 67 72 65 70 20  ${file}" | grep 
02a0: 2d 2d 20 27 2d 62 75 69 6c 64 2e 6c 6f 67 24 27  -- '-build.log$'
02b0: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65   >/dev/null; the
02c0: 6e 0a 09 09 63 6f 6e 74 69 6e 75 65 0a 09 66 69  n...continue..fi
02d0: 0a 0a 09 72 6d 20 2d 66 20 22 24 7b 66 69 6c 65  ...rm -f "${file
02e0: 7d 22 0a 64 6f 6e 65 0a 0a 66 61 69 6c 65 64 3d  }".done..failed=
02f0: 22 22 0a 66 6f 72 20 6b 69 74 20 69 6e 20 6e 6f  "".for kit in no
0300: 72 6d 61 6c 20 6e 6f 72 6d 61 6c 2d 7a 69 70 20  rmal normal-zip 
0310: 6e 6f 72 6d 61 6c 2d 74 68 72 65 61 64 65 64 20  normal-threaded 
0320: 6e 6f 72 6d 61 6c 2d 74 68 72 65 61 64 65 64 2d  normal-threaded-
0330: 7a 69 70 20 6e 6f 72 6d 61 6c 2d 6e 6f 74 6b 20  zip normal-notk 
0340: 6e 6f 72 6d 61 6c 2d 74 68 72 65 61 64 65 64 2d  normal-threaded-
0350: 6e 6f 74 6b 20 6e 6f 72 6d 61 6c 2d 74 68 72 65  notk normal-thre
0360: 61 64 65 64 2d 7a 69 70 2d 6e 6f 74 6b 20 6d 69  aded-zip-notk mi
0370: 6e 20 6d 69 6e 2d 73 74 61 74 69 63 20 77 69 6e  n min-static win
0380: 33 32 20 77 69 6e 33 32 2d 7a 69 70 20 77 69 6e  32 win32-zip win
0390: 33 32 2d 74 68 72 65 61 64 65 64 20 77 69 6e 33  32-threaded win3
03a0: 32 2d 74 68 72 65 61 64 65 64 2d 7a 69 70 20 77  2-threaded-zip w
03b0: 69 6e 33 32 2d 6e 6f 74 6b 20 77 69 6e 33 32 2d  in32-notk win32-
03c0: 74 68 72 65 61 64 65 64 2d 6e 6f 74 6b 20 61 72  threaded-notk ar
03d0: 6d 2d 6d 69 6e 3b 20 64 6f 0a 09 6b 69 74 63 72  m-min; do..kitcr
03e0: 65 61 74 6f 72 3d 22 2e 2f 6b 69 74 63 72 65 61  eator="./kitcrea
03f0: 74 6f 72 22 0a 09 61 72 67 73 3d 22 22 0a 09 72  tor"..args=""..r
0400: 75 6e 6e 61 62 6c 65 3d 22 31 22 0a 09 69 73 7a  unnable="1"..isz
0410: 69 70 3d 22 30 22 0a 09 73 74 61 74 69 63 74 6b  ip="0"..statictk
0420: 3d 22 30 22 0a 09 6e 6f 74 6b 3d 22 30 22 0a 0a  ="0"..notk="0"..
0430: 09 23 20 48 61 6e 64 6c 65 20 62 61 73 65 20 63  .# Handle base c
0440: 6f 6e 66 69 67 75 72 61 74 69 6f 6e 0a 09 63 61  onfiguration..ca
0450: 73 65 20 22 24 7b 6b 69 74 7d 22 20 69 6e 0a 09  se "${kit}" in..
0460: 09 6e 6f 72 6d 61 6c 7c 6e 6f 72 6d 61 6c 2d 2a  .normal|normal-*
0470: 29 0a 09 09 09 74 72 75 65 0a 09 09 09 3b 3b 0a  )....true....;;.
0480: 09 09 6d 69 6e 29 0a 09 09 09 6b 69 74 63 72 65  ..min)....kitcre
0490: 61 74 6f 72 3d 22 2e 2f 62 75 69 6c 64 2f 6d 61  ator="./build/ma
04a0: 6b 65 2d 6d 69 6e 6b 69 74 22 0a 09 09 09 69 73  ke-minkit"....is
04b0: 7a 69 70 3d 22 31 22 0a 09 09 09 6e 6f 74 6b 3d  zip="1"....notk=
04c0: 22 31 22 0a 09 09 09 3b 3b 0a 09 09 6d 69 6e 2d  "1"....;;...min-
04d0: 73 74 61 74 69 63 29 0a 09 09 09 6b 69 74 63 72  static)....kitcr
04e0: 65 61 74 6f 72 3d 22 2e 2f 62 75 69 6c 64 2f 6d  eator="./build/m
04f0: 61 6b 65 2d 6d 69 6e 6b 69 74 2d 73 74 61 74 69  ake-minkit-stati
0500: 63 22 0a 09 09 09 69 73 7a 69 70 3d 22 31 22 0a  c"....iszip="1".
0510: 09 09 09 6e 6f 74 6b 3d 22 31 22 0a 09 09 09 3b  ...notk="1"....;
0520: 3b 0a 09 09 77 69 6e 33 32 7c 77 69 6e 33 32 2d  ;...win32|win32-
0530: 2a 29 0a 09 09 09 6b 69 74 63 72 65 61 74 6f 72  *)....kitcreator
0540: 3d 22 2e 2f 62 75 69 6c 64 2f 6d 61 6b 65 2d 6b  ="./build/make-k
0550: 69 74 2d 77 69 6e 33 32 22 0a 09 09 09 72 75 6e  it-win32"....run
0560: 6e 61 62 6c 65 3d 22 30 22 0a 09 09 09 3b 3b 0a  nable="0"....;;.
0570: 09 09 61 72 6d 2d 6d 69 6e 29 0a 09 09 09 6b 69  ..arm-min)....ki
0580: 74 63 72 65 61 74 6f 72 3d 22 2e 2f 62 75 69 6c  tcreator="./buil
0590: 64 2f 6d 61 6b 65 2d 6b 69 74 2d 61 72 6d 22 0a  d/make-kit-arm".
05a0: 09 09 09 72 75 6e 6e 61 62 6c 65 3d 22 30 22 0a  ...runnable="0".
05b0: 09 09 09 6e 6f 74 6b 3d 22 31 22 0a 09 09 09 69  ...notk="1"....i
05c0: 73 7a 69 70 3d 22 31 22 0a 09 09 09 3b 3b 0a 09  szip="1"....;;..
05d0: 65 73 61 63 0a 0a 09 23 20 48 61 6e 64 6c 65 20  esac...# Handle 
05e0: 61 64 64 69 74 69 6f 6e 61 6c 20 63 6f 6e 66 69  additional confi
05f0: 67 75 72 61 74 69 6f 6e 0a 09 74 65 6d 70 6b 69  guration..tempki
0600: 74 3d 22 2d 24 7b 6b 69 74 7d 2d 22 0a 09 66 6f  t="-${kit}-"..fo
0610: 72 20 74 72 79 20 69 6e 20 31 20 32 20 33 20 34  r try in 1 2 3 4
0620: 20 35 20 36 20 37 20 38 20 39 3b 20 64 6f 0a 09   5 6 7 8 9; do..
0630: 09 63 61 73 65 20 22 2d 24 7b 74 65 6d 70 6b 69  .case "-${tempki
0640: 74 7d 2d 22 20 69 6e 0a 09 09 09 2a 2d 74 68 72  t}-" in....*-thr
0650: 65 61 64 65 64 2d 2a 29 0a 09 09 09 09 74 65 6d  eaded-*).....tem
0660: 70 6b 69 74 3d 22 24 28 65 63 68 6f 20 22 24 7b  pkit="$(echo "${
0670: 74 65 6d 70 6b 69 74 7d 22 20 7c 20 73 65 64 20  tempkit}" | sed 
0680: 27 73 40 2d 74 68 72 65 61 64 65 64 2d 40 2d 40  's@-threaded-@-@
0690: 27 29 22 0a 09 09 09 09 61 72 67 73 3d 22 24 7b  ')".....args="${
06a0: 61 72 67 73 7d 20 2d 2d 65 6e 61 62 6c 65 2d 74  args} --enable-t
06b0: 68 72 65 61 64 73 22 0a 09 09 09 09 3b 3b 0a 09  hreads".....;;..
06c0: 09 09 2a 2d 7a 69 70 2d 2a 29 0a 09 09 09 09 74  ..*-zip-*).....t
06d0: 65 6d 70 6b 69 74 3d 22 24 28 65 63 68 6f 20 22  empkit="$(echo "
06e0: 24 7b 74 65 6d 70 6b 69 74 7d 22 20 7c 20 73 65  ${tempkit}" | se
06f0: 64 20 27 73 40 2d 7a 69 70 2d 40 2d 40 27 29 22  d 's@-zip-@-@')"
0700: 0a 09 09 09 09 61 72 67 73 3d 22 24 7b 61 72 67  .....args="${arg
0710: 73 7d 20 2d 2d 65 6e 61 62 6c 65 2d 6b 69 74 2d  s} --enable-kit-
0720: 73 74 6f 72 61 67 65 3d 7a 69 70 22 0a 09 09 09  storage=zip"....
0730: 09 69 73 7a 69 70 3d 22 31 22 0a 09 09 09 09 3b  .iszip="1".....;
0740: 3b 0a 09 09 09 2a 2d 73 74 61 74 69 63 74 6b 2d  ;....*-statictk-
0750: 2a 29 0a 09 09 09 09 74 65 6d 70 6b 69 74 3d 22  *).....tempkit="
0760: 24 28 65 63 68 6f 20 22 24 7b 74 65 6d 70 6b 69  $(echo "${tempki
0770: 74 7d 22 20 7c 20 73 65 64 20 27 73 40 2d 73 74  t}" | sed 's@-st
0780: 61 74 69 63 74 6b 2d 40 2d 40 27 29 22 0a 09 09  atictk-@-@')"...
0790: 09 09 69 66 20 5b 20 22 24 7b 6e 6f 74 6b 7d 22  ..if [ "${notk}"
07a0: 20 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a 09   = "0" ]; then..
07b0: 09 09 09 09 73 74 61 74 69 63 74 6b 3d 22 31 22  ....statictk="1"
07c0: 0a 09 09 09 09 65 6c 73 65 0a 09 09 09 09 09 65  .....else......e
07d0: 63 68 6f 20 22 24 7b 6b 69 74 7d 3a 20 55 6e 61  cho "${kit}: Una
07e0: 62 6c 65 20 74 6f 20 63 72 65 61 74 65 20 53 74  ble to create St
07f0: 61 74 69 63 54 6b 20 61 6e 64 20 4e 6f 54 6b 2c  aticTk and NoTk,
0800: 20 69 67 6e 6f 72 69 6e 67 20 53 74 61 74 69 63   ignoring Static
0810: 54 6b 22 20 3e 26 32 0a 09 09 09 09 66 69 0a 09  Tk" >&2.....fi..
0820: 09 09 09 3b 3b 0a 09 09 09 2a 2d 6e 6f 74 6b 2d  ...;;....*-notk-
0830: 2a 29 0a 09 09 09 09 74 65 6d 70 6b 69 74 3d 22  *).....tempkit="
0840: 24 28 65 63 68 6f 20 22 24 7b 74 65 6d 70 6b 69  $(echo "${tempki
0850: 74 7d 22 20 7c 20 73 65 64 20 27 73 40 2d 6e 6f  t}" | sed 's@-no
0860: 74 6b 2d 40 2d 40 27 29 22 0a 09 09 09 09 69 66  tk-@-@')".....if
0870: 20 5b 20 22 24 7b 73 74 61 74 69 63 74 6b 7d 22   [ "${statictk}"
0880: 20 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a 09   = "0" ]; then..
0890: 09 09 09 09 6e 6f 74 6b 3d 22 31 22 0a 09 09 09  ....notk="1"....
08a0: 09 65 6c 73 65 0a 09 09 09 09 09 65 63 68 6f 20  .else......echo 
08b0: 22 24 7b 6b 69 74 7d 3a 20 55 6e 61 62 6c 65 20  "${kit}: Unable 
08c0: 74 6f 20 63 72 65 61 74 65 20 53 74 61 74 69 63  to create Static
08d0: 54 6b 20 61 6e 64 20 4e 6f 54 6b 2c 20 69 67 6e  Tk and NoTk, ign
08e0: 6f 72 69 6e 67 20 4e 6f 54 6b 22 20 3e 26 32 0a  oring NoTk" >&2.
08f0: 09 09 09 09 66 69 0a 09 09 09 09 3b 3b 0a 09 09  ....fi.....;;...
0900: 65 73 61 63 0a 09 64 6f 6e 65 0a 0a 09 66 6f 72  esac..done...for
0910: 20 76 65 72 73 69 6f 6e 20 69 6e 20 24 7b 56 45   version in ${VE
0920: 52 53 49 4f 4e 53 7d 3b 20 64 6f 0a 09 09 23 20  RSIONS}; do...# 
0930: 43 72 65 61 74 65 20 54 63 6c 6b 69 74 0a 09 09  Create Tclkit...
0940: 63 72 65 61 74 65 64 6b 69 74 3d 22 74 63 6c 6b  createdkit="tclk
0950: 69 74 2d 24 7b 76 65 72 73 69 6f 6e 7d 22 0a 09  it-${version}"..
0960: 09 6f 75 74 70 75 74 6e 61 6d 65 3d 22 24 7b 54  .outputname="${T
0970: 45 53 54 44 49 52 7d 2f 6b 69 74 73 2f 74 63 6c  ESTDIR}/kits/tcl
0980: 6b 69 74 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24  kit-${version}-$
0990: 7b 6b 69 74 7d 22 0a 09 09 62 75 69 6c 64 6c 6f  {kit}"...buildlo
09a0: 67 3d 22 24 7b 6f 75 74 70 75 74 6e 61 6d 65 7d  g="${outputname}
09b0: 2d 62 75 69 6c 64 2e 6c 6f 67 22 0a 0a 09 09 69  -build.log"....i
09c0: 66 20 5b 20 21 20 2d 66 20 22 24 7b 6f 75 74 70  f [ ! -f "${outp
09d0: 75 74 6e 61 6d 65 7d 22 20 5d 3b 20 74 68 65 6e  utname}" ]; then
09e0: 0a 09 09 09 75 6e 73 65 74 20 4b 49 54 43 52 45  ....unset KITCRE
09f0: 41 54 4f 52 5f 50 4b 47 53 20 53 54 41 54 49 43  ATOR_PKGS STATIC
0a00: 54 4b 0a 0a 09 09 09 65 63 68 6f 20 22 43 72 65  TK.....echo "Cre
0a10: 61 74 69 6e 67 20 54 63 6c 6b 69 74 20 24 7b 76  ating Tclkit ${v
0a20: 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 2e 2e  ersion}/${kit}..
0a30: 2e 22 0a 0a 09 09 09 69 66 20 5b 20 22 24 7b 6e  .".....if [ "${n
0a40: 6f 74 6b 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74  otk}" = "1" ]; t
0a50: 68 65 6e 0a 09 09 09 09 4b 49 54 43 52 45 41 54  hen.....KITCREAT
0a60: 4f 52 5f 50 4b 47 53 3d 27 69 74 63 6c 20 6d 6b  OR_PKGS='itcl mk
0a70: 34 74 63 6c 27 0a 09 09 09 09 65 78 70 6f 72 74  4tcl'.....export
0a80: 20 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53   KITCREATOR_PKGS
0a90: 0a 09 09 09 66 69 0a 0a 09 09 09 69 66 20 5b 20  ....fi.....if [ 
0aa0: 22 24 7b 73 74 61 74 69 63 74 6b 7d 22 20 3d 20  "${statictk}" = 
0ab0: 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09  "1" ]; then.....
0ac0: 53 54 41 54 49 43 54 4b 3d 22 31 22 0a 09 09 09  STATICTK="1"....
0ad0: 09 65 78 70 6f 72 74 20 53 54 41 54 49 43 54 4b  .export STATICTK
0ae0: 0a 09 09 09 66 69 0a 0a 09 09 09 62 75 69 6c 64  ....fi.....build
0af0: 66 61 69 6c 65 64 3d 22 30 22 0a 09 09 09 22 24  failed="0"...."$
0b00: 7b 6b 69 74 63 72 65 61 74 6f 72 7d 22 20 22 24  {kitcreator}" "$
0b10: 7b 76 65 72 73 69 6f 6e 7d 22 20 24 7b 61 72 67  {version}" ${arg
0b20: 73 7d 20 3e 20 22 24 7b 62 75 69 6c 64 6c 6f 67  s} > "${buildlog
0b30: 7d 22 20 32 3e 26 31 20 7c 7c 20 62 75 69 6c 64  }" 2>&1 || build
0b40: 66 61 69 6c 65 64 3d 22 31 22 0a 09 09 09 67 72  failed="1"....gr
0b50: 65 70 20 2d 6e 20 27 5e 27 20 2a 2f 62 75 69 6c  ep -n '^' */buil
0b60: 64 2e 6c 6f 67 20 3e 3e 20 22 24 7b 62 75 69 6c  d.log >> "${buil
0b70: 64 6c 6f 67 7d 22 20 32 3e 26 31 0a 0a 09 09 09  dlog}" 2>&1.....
0b80: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 63 72 65  if [ ! -f "${cre
0b90: 61 74 65 64 6b 69 74 7d 22 20 5d 3b 20 74 68 65  atedkit}" ]; the
0ba0: 6e 0a 09 09 09 09 65 63 68 6f 20 22 46 61 69 6c  n.....echo "Fail
0bb0: 65 64 20 74 6f 20 63 72 65 61 74 65 20 6b 69 74  ed to create kit
0bc0: 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69   ${version}/${ki
0bd0: 74 7d 22 20 3e 26 32 0a 0a 09 09 09 09 66 61 69  t}" >&2......fai
0be0: 6c 65 64 3d 22 24 7b 66 61 69 6c 65 64 7d 20 24  led="${failed} $
0bf0: 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d  {version}/${kit}
0c00: 2d 62 75 69 6c 64 22 0a 0a 09 09 09 09 63 6f 6e  -build"......con
0c10: 74 69 6e 75 65 0a 09 09 09 66 69 0a 0a 09 09 09  tinue....fi.....
0c20: 23 20 56 65 72 69 66 79 20 73 61 6e 69 74 79 20  # Verify sanity 
0c30: 6f 66 20 63 72 65 61 74 65 64 20 6b 69 74 0a 09  of created kit..
0c40: 09 09 69 73 73 61 6e 65 3d 31 0a 0a 09 09 09 23  ..issane=1.....#
0c50: 23 20 56 65 72 69 66 79 20 74 68 65 20 57 69 6e  # Verify the Win
0c60: 33 32 20 6b 69 74 73 20 61 72 65 20 0a 09 09 09  32 kits are ....
0c70: 63 61 73 65 20 22 2d 24 7b 76 65 72 73 69 6f 6e  case "-${version
0c80: 7d 2d 24 7b 6b 69 74 7d 2d 22 20 69 6e 0a 09 09  }-${kit}-" in...
0c90: 09 09 2a 2d 77 69 6e 33 32 2d 6e 6f 74 6b 2d 2a  ..*-win32-notk-*
0ca0: 7c 2a 2d 77 69 6e 33 32 2d 2a 2d 6e 6f 74 6b 2d  |*-win32-*-notk-
0cb0: 2a 29 0a 09 09 09 09 09 69 66 20 21 20 66 69 6c  *)......if ! fil
0cc0: 65 20 22 24 7b 63 72 65 61 74 65 64 6b 69 74 7d  e "${createdkit}
0cd0: 22 20 7c 20 67 72 65 70 20 27 4d 53 20 57 69 6e  " | grep 'MS Win
0ce0: 64 6f 77 73 20 28 63 6f 6e 73 6f 6c 65 29 27 20  dows (console)' 
0cf0: 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e  >/dev/null; then
0d00: 0a 09 09 09 09 09 09 65 63 68 6f 20 22 4b 69 74  .......echo "Kit
0d10: 20 66 61 69 6c 65 64 20 73 61 6e 69 74 79 20 63   failed sanity c
0d20: 68 65 63 6b 20 66 6f 72 20 62 65 69 6e 67 20 61  heck for being a
0d30: 20 63 6f 6e 73 6f 6c 65 20 61 70 70 6c 69 63 61   console applica
0d40: 74 69 6f 6e 22 20 3e 26 32 0a 09 09 09 09 09 09  tion" >&2.......
0d50: 69 73 73 61 6e 65 3d 30 0a 09 09 09 09 09 66 69  issane=0......fi
0d60: 0a 09 09 09 09 09 3b 3b 0a 09 09 09 09 2a 2d 77  ......;;.....*-w
0d70: 69 6e 33 32 2d 2a 29 0a 09 09 09 09 09 69 66 20  in32-*)......if 
0d80: 21 20 66 69 6c 65 20 22 24 7b 63 72 65 61 74 65  ! file "${create
0d90: 64 6b 69 74 7d 22 20 7c 20 67 72 65 70 20 27 4d  dkit}" | grep 'M
0da0: 53 20 57 69 6e 64 6f 77 73 20 28 47 55 49 29 27  S Windows (GUI)'
0db0: 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65   >/dev/null; the
0dc0: 6e 0a 09 09 09 09 09 09 65 63 68 6f 20 22 4b 69  n.......echo "Ki
0dd0: 74 20 66 61 69 6c 65 64 20 73 61 6e 69 74 79 20  t failed sanity 
0de0: 63 68 65 63 6b 20 66 6f 72 20 62 65 69 6e 67 20  check for being 
0df0: 61 20 47 55 49 20 61 70 70 6c 69 63 61 74 69 6f  a GUI applicatio
0e00: 6e 22 20 3e 26 32 0a 09 09 09 09 09 09 69 73 73  n" >&2.......iss
0e10: 61 6e 65 3d 30 0a 09 09 09 09 09 66 69 0a 09 09  ane=0......fi...
0e20: 09 09 09 3b 3b 0a 09 09 09 65 73 61 63 0a 0a 09  ...;;....esac...
0e30: 09 09 23 23 20 56 65 72 69 66 79 20 74 68 65 20  ..## Verify the 
0e40: 62 75 69 6c 64 20 63 6f 6d 70 6c 65 74 65 64 20  build completed 
0e50: 77 69 74 68 6f 75 74 20 77 61 72 6e 69 6e 67 73  without warnings
0e60: 0a 09 09 09 69 66 20 5b 20 22 24 7b 62 75 69 6c  ....if [ "${buil
0e70: 64 66 61 69 6c 65 64 7d 22 20 3d 20 22 31 22 20  dfailed}" = "1" 
0e80: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 65 63 68 6f  ]; then.....echo
0e90: 20 22 4b 69 74 20 66 61 69 6c 65 64 20 73 61 6e   "Kit failed san
0ea0: 69 74 79 20 63 68 65 63 6b 20 66 6f 72 20 42 75  ity check for Bu
0eb0: 69 6c 64 69 6e 67 22 20 3e 26 32 0a 0a 09 09 09  ilding" >&2.....
0ec0: 09 69 73 73 61 6e 65 3d 30 0a 09 09 09 66 69 0a  .issane=0....fi.
0ed0: 0a 09 09 09 23 20 4d 61 6b 65 20 6e 6f 74 65 20  ....# Make note 
0ee0: 6f 66 20 73 61 6e 69 74 79 20 66 61 69 6c 75 72  of sanity failur
0ef0: 65 0a 09 09 09 69 66 20 5b 20 22 24 7b 69 73 73  e....if [ "${iss
0f00: 61 6e 65 7d 22 20 21 3d 20 22 31 22 20 5d 3b 20  ane}" != "1" ]; 
0f10: 74 68 65 6e 0a 09 09 09 09 65 63 68 6f 20 22 4b  then.....echo "K
0f20: 69 74 20 66 61 69 6c 65 64 20 73 61 6e 69 74 79  it failed sanity
0f30: 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69   ${version}/${ki
0f40: 74 7d 22 20 3e 26 32 0a 0a 09 09 09 09 66 61 69  t}" >&2......fai
0f50: 6c 65 64 3d 22 24 7b 66 61 69 6c 65 64 7d 20 24  led="${failed} $
0f60: 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d  {version}/${kit}
0f70: 2d 73 61 6e 69 74 79 22 0a 0a 09 09 09 09 72 6d  -sanity"......rm
0f80: 20 2d 66 20 22 24 7b 63 72 65 61 74 65 64 6b 69   -f "${createdki
0f90: 74 7d 22 0a 0a 09 09 09 09 63 6f 6e 74 69 6e 75  t}"......continu
0fa0: 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20 52 65  e....fi.....# Re
0fb0: 6e 61 6d 65 20 63 72 65 61 74 65 64 20 6b 69 74  name created kit
0fc0: 20 74 6f 20 66 69 6e 61 6c 20 64 65 73 74 69 6e   to final destin
0fd0: 61 74 69 6f 6e 0a 09 09 09 6d 76 20 22 24 7b 63  ation....mv "${c
0fe0: 72 65 61 74 65 64 6b 69 74 7d 22 20 22 24 7b 6f  reatedkit}" "${o
0ff0: 75 74 70 75 74 6e 61 6d 65 7d 22 0a 09 09 66 69  utputname}"...fi
1000: 0a 0a 09 09 23 20 54 65 73 74 20 7a 69 70 20 73  ....# Test zip s
1010: 74 61 74 75 73 0a 09 09 69 66 20 75 6e 7a 69 70  tatus...if unzip
1020: 20 2d 6c 20 22 24 7b 6f 75 74 70 75 74 6e 61 6d   -l "${outputnam
1030: 65 7d 22 20 32 3e 26 31 20 7c 20 67 72 65 70 20  e}" 2>&1 | grep 
1040: 27 62 6f 6f 74 5c 2e 74 63 6c 27 20 3e 2f 64 65  'boot\.tcl' >/de
1050: 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 09  v/null; then....
1060: 63 61 6e 75 6e 7a 69 70 3d 22 31 22 0a 09 09 65  canunzip="1"...e
1070: 6c 73 65 0a 09 09 09 63 61 6e 75 6e 7a 69 70 3d  lse....canunzip=
1080: 22 30 22 0a 09 09 66 69 0a 0a 09 09 69 66 20 5b  "0"...fi....if [
1090: 20 22 24 7b 69 73 7a 69 70 7d 22 20 21 3d 20 22   "${iszip}" != "
10a0: 24 7b 63 61 6e 75 6e 7a 69 70 7d 22 20 5d 3b 20  ${canunzip}" ]; 
10b0: 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 46 61  then....echo "Fa
10c0: 69 6c 65 64 20 74 6f 20 75 6e 7a 69 70 20 7a 69  iled to unzip zi
10d0: 70 6b 69 74 20 6f 72 20 77 61 73 20 61 62 6c 65  pkit or was able
10e0: 20 74 6f 20 75 6e 7a 69 70 20 6e 6f 6e 2d 7a 69   to unzip non-zi
10f0: 70 6b 69 74 20 24 7b 76 65 72 73 69 6f 6e 7d 2f  pkit ${version}/
1100: 24 7b 6b 69 74 7d 22 20 3e 26 32 0a 0a 09 09 09  ${kit}" >&2.....
1110: 66 61 69 6c 65 64 3d 22 24 7b 66 61 69 6c 65 64  failed="${failed
1120: 7d 20 24 7b 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b  } ${version}/${k
1130: 69 74 7d 2d 7a 69 70 22 0a 0a 09 09 09 63 6f 6e  it}-zip".....con
1140: 74 69 6e 75 65 0a 09 09 66 69 0a 0a 09 09 23 20  tinue...fi....# 
1150: 44 6f 20 6e 6f 74 20 63 6f 6e 74 69 6e 75 65 20  Do not continue 
1160: 70 61 73 74 20 68 65 72 65 20 66 6f 72 20 75 6e  past here for un
1170: 2d 72 75 6e 6e 61 62 6c 65 20 6b 69 74 73 0a 09  -runnable kits..
1180: 09 69 66 20 5b 20 22 24 7b 72 75 6e 6e 61 62 6c  .if [ "${runnabl
1190: 65 7d 22 20 21 3d 20 22 31 22 20 5d 3b 20 74 68  e}" != "1" ]; th
11a0: 65 6e 0a 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09  en....continue..
11b0: 09 66 69 0a 0a 09 09 23 20 50 65 72 66 6f 72 6d  .fi....# Perform
11c0: 20 62 61 74 74 65 72 79 20 6f 66 20 74 65 73 74   battery of test
11d0: 73 0a 09 09 66 6f 72 20 74 65 73 74 73 63 70 20  s...for testscp 
11e0: 69 6e 20 22 24 7b 54 45 53 54 44 49 52 7d 22 2f  in "${TESTDIR}"/
11f0: 74 65 73 74 73 2f 2a 2e 74 63 6c 3b 20 64 6f 0a  tests/*.tcl; do.
1200: 09 09 09 74 65 73 74 73 63 70 5f 74 61 67 3d 22  ...testscp_tag="
1210: 24 28 62 61 73 65 6e 61 6d 65 20 22 24 7b 74 65  $(basename "${te
1220: 73 74 73 63 70 7d 22 20 2e 74 63 6c 29 22 0a 09  stscp}" .tcl)"..
1230: 09 09 74 65 73 74 73 63 70 70 72 65 3d 22 24 28  ..testscppre="$(
1240: 64 69 72 6e 61 6d 65 20 22 24 7b 74 65 73 74 73  dirname "${tests
1250: 63 70 7d 22 29 2f 24 7b 74 65 73 74 73 63 70 5f  cp}")/${testscp_
1260: 74 61 67 7d 2e 73 68 22 0a 09 09 09 73 63 70 6c  tag}.sh"....scpl
1270: 6f 67 66 69 6c 65 3d 22 24 7b 6f 75 74 70 75 74  ogfile="${output
1280: 6e 61 6d 65 7d 2d 24 7b 74 65 73 74 73 63 70 5f  name}-${testscp_
1290: 74 61 67 7d 2e 6c 6f 67 22 0a 0a 09 09 09 28 0a  tag}.log".....(.
12a0: 09 09 09 09 69 66 20 5b 20 2d 66 20 22 24 7b 74  ....if [ -f "${t
12b0: 65 73 74 73 63 70 70 72 65 7d 22 20 5d 3b 20 74  estscppre}" ]; t
12c0: 68 65 6e 0a 09 09 09 09 09 2e 20 22 24 7b 74 65  hen....... "${te
12d0: 73 74 73 63 70 70 72 65 7d 22 0a 09 09 09 09 66  stscppre}".....f
12e0: 69 0a 0a 09 09 09 09 22 24 7b 6f 75 74 70 75 74  i......"${output
12f0: 6e 61 6d 65 7d 22 20 22 24 7b 74 65 73 74 73 63  name}" "${testsc
1300: 70 7d 22 20 22 24 7b 6f 75 74 70 75 74 6e 61 6d  p}" "${outputnam
1310: 65 7d 22 20 22 24 7b 6b 69 74 7d 22 20 22 24 7b  e}" "${kit}" "${
1320: 76 65 72 73 69 6f 6e 7d 22 0a 09 09 09 29 20 3e  version}"....) >
1330: 20 22 24 7b 73 63 70 6c 6f 67 66 69 6c 65 7d 22   "${scplogfile}"
1340: 20 32 3e 26 31 0a 0a 09 09 09 69 66 20 5b 20 22   2>&1.....if [ "
1350: 24 3f 22 20 21 3d 20 22 30 22 20 5d 3b 20 74 68  $?" != "0" ]; th
1360: 65 6e 0a 09 09 09 09 65 63 68 6f 20 22 53 63 72  en.....echo "Scr
1370: 69 70 74 20 66 61 69 6c 65 64 3a 20 24 7b 74 65  ipt failed: ${te
1380: 73 74 73 63 70 5f 74 61 67 7d 20 6f 6e 20 24 7b  stscp_tag} on ${
1390: 76 65 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 22  version}/${kit}"
13a0: 20 3e 26 32 0a 0a 09 09 09 09 66 61 69 6c 65 64   >&2......failed
13b0: 3d 22 24 7b 66 61 69 6c 65 64 7d 20 24 7b 76 65  ="${failed} ${ve
13c0: 72 73 69 6f 6e 7d 2f 24 7b 6b 69 74 7d 2d 74 65  rsion}/${kit}-te
13d0: 73 74 2d 24 7b 74 65 73 74 73 63 70 5f 74 61 67  st-${testscp_tag
13e0: 7d 22 0a 0a 09 09 09 09 63 6f 6e 74 69 6e 75 65  }"......continue
13f0: 0a 09 09 09 66 69 0a 09 09 64 6f 6e 65 0a 09 64  ....fi...done..d
1400: 6f 6e 65 0a 64 6f 6e 65 0a 0a 69 66 20 5b 20 2d  one.done..if [ -
1410: 6e 20 22 24 7b 66 61 69 6c 65 64 7d 22 20 5d 3b  n "${failed}" ];
1420: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 46 61 69   then..echo "Fai
1430: 6c 65 64 3a 20 24 7b 66 61 69 6c 65 64 7d 22 0a  led: ${failed}".
1440: 66 69 0a                                         fi.